%P. Kano
%August 24, 2005

function [ExpMatrix] = MWeeksClenshawAlgorithm(NNodes,NLaguerreCoef,SigmaWeeks,BetaWeeks,LaguerreCoef)

%Clenshaw's Algorithm
CCNp2(1:1:NNodes,1:1:NNodes,1) = 0;
CCNp1(1:1:NNodes,1:1:NNodes,1) = LaguerreCoef(:,:,NLaguerreCoef);
for k=(NLaguerreCoef-1):-1:1
CCNpresent(:,:,1) = (2*k-1-(2*BetaWeeks))/k.*CCNp1(:,:,1) - k/(k+1).*CCNp2(:,:,1) + LaguerreCoef(:,:,k);
CCNp2(:,:,1) = CCNp1(:,:,1); CCNp1(:,:,1) = CCNpresent(:,:,1);  
end
 
ExpMatrix(:,:,1) = exp((SigmaWeeks-BetaWeeks)).*CCNpresent(:,:,1);
