%P. Kano
%November 8, 2005

function [Rinverse] = WeeksMinBeta(BetaWeeks,SigmaWeeks,Trianmatrix)

%Find Radius of Convergence of Power Series in W-plane =
%Distance to nearest eigenvalues to the origin = 
%Eigenvalue with the smallest absolute value
Diagvec = diag(Trianmatrix);
Weigs = (Diagvec-SigmaWeeks-BetaWeeks)./(Diagvec-SigmaWeeks+BetaWeeks);
Rconvergence = min(abs(Weigs));
Rinverse = 1/Rconvergence;





